unit frmsp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TFormPW = class(TForm)
    EdFile: TEdit;
    BtnSelectFile: TButton;
    EdPassword: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    btnClose: TButton;
    EdModifier: TEdit;
    Label3: TLabel;
    filedialog: TOpenDialog;
    BtnGenerate: TButton;
    EdOffset: TEdit;
    LblOff: TLabel;
    procedure BtnSelectFileClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure BtnGenerateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormPW: TFormPW;

implementation

{$R *.DFM}

procedure TFormPW.BtnSelectFileClick(Sender: TObject);
var fSize : Longint;
f : tfilestream;
begin
  if filedialog.Execute then
    begin
      EdFile.Text := filedialog.FileName;
      BtnGenerate.Enabled :=  fileexists(EdFile.Text);
      if BtnGenerate.Enabled then
        begin
          f := tfilestream.Create(Edfile.text,fmopenread);
          lbloff.Caption := 'Offset : Size = '+IntTostr( f.Size );
          f.Free;
        end;
    end;
end;

procedure TFormPW.btnCloseClick(Sender: TObject);
begin
  close;
end;

procedure TFormPW.BtnGenerateClick(Sender: TObject);
var f : tfilestream;
s : tstringstream;
numBytes,byoff,i,pwl,offval : longint;
by,bym: byte;
modstr,outstr : string;
begin
  try
    OffVal := strtoint( EdOffset.text);
  except
    OffVal := 0;
  end;
  outstr := '';
  modstr := EdModifier.Text;
  f := tfilestream.Create(Edfile.text,fmopenread);
  s := tstringstream.Create('');
  try
    f.Seek(Offval, soFromBeginning);
    Numbytes := s.CopyFrom(f,f.size-Offval);
  except
    NumBytes := 0;
  end;
  f.free;
  If Numbytes < 32 then
    begin
      ShowMessage('Insufficient Bytes read- Please choose another file or reduce the offset');
      exit;
    end;
  pwl := numbytes;
  if pwl > 80 then
    pwl := 80;
  byoff := 1;
  for i:= 1 to pwl do
    begin
      by := ord( s.datastring[i] ) and $7f;
      if ModStr <>'' then
        begin
          by := by xor ord( Modstr[byoff] );
        end;
      inc(byoff);
      if byoff > length(modstr) then
        byoff := 1;

      if by < 32 then
        by := by or 32;
      outstr := outstr + chr(by);
   end;
  EdPassword.Text := Outstr;
  EdPassword.SelectAll;
  EdPassword.CopyToClipboard;
end;

end.
